//CAClient2.cpp
#include <objbase.h> //CAClient
#include <stdio.h>   //IID_IClassFactory={00000001-0000-0000-C000-000000000046};
const CLSID CLSID_CA ={0x20000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04}}; //Class ID of Class CA, ie., Class A
const IID   IID_I_X  ={0x20000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05}}; //Interface X 
const IID   IID_I_Y  ={0x20000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06}}; //Interface Y 
const IID   IID_Junk ={0x12345678,0x9876,0x5432,{0x12,0x34,0x56,0x78,0x98,0x76,0x54,0x32}}; //Junk Number So QueryInterface() Fails 


HRESULT (__stdcall* ptrQueryInterface) (int, const IID&, void**);
ULONG   (__stdcall* ptrAddRef)         (int);
ULONG   (__stdcall* ptrRelease)        (int);
void    (__stdcall* pIFn)              (int,int);


interface I_X : IUnknown
{
 virtual HRESULT __stdcall Fx1(int)=0;
 virtual HRESULT __stdcall Fx2(int)=0;
};


interface I_Y : IUnknown
{
 virtual HRESULT __stdcall Fy1(int)=0;
 virtual HRESULT __stdcall Fy2(int)=0;
};


int main(void)
{
 IClassFactory*  pCF=NULL;
 IUnknown*       pIUnk=NULL;
 unsigned int*   pVTbl=0;
 unsigned int*   VTbl=0;
  
 CoInitialize(NULL);
 CoGetClassObject(CLSID_CA,CLSCTX_INPROC_SERVER,NULL,IID_IClassFactory,(void**)&pCF);
 pCF->CreateInstance(NULL,IID_IUnknown,(void**)&pVTbl);
 pCF->Release();
 printf("pVTbl   = %u\n",pVTbl);
 printf("\n");
 printf("&pVTbl[i]\t&VTbl[i]\tVTbl[i]\t\tFunction Call Through Pointer\n");
 printf("=============================================================================\n");
 for(unsigned int i=0;i<=1;i++)
 {
     VTbl=(unsigned int*)pVTbl[i];                                             //Call...
     printf("%u\t%u\t%u\t",&pVTbl[i],&VTbl[0],VTbl[0]);   
     ptrQueryInterface=(HRESULT(__stdcall*)(int, const IID&, void**)) VTbl[0]; 
     ptrQueryInterface((int)&pVTbl[i],IID_Junk,(void**)&pIUnk);                //QueryInterface() 
     printf("%u\t%u\t%u\t",&pVTbl[i],&VTbl[1],VTbl[1]);                        
     ptrAddRef=(ULONG(__stdcall*)(int)) VTbl[1];
     ptrAddRef((int)&pVTbl[i]);                                                //AddRef()
     printf("%u\t%u\t%u\t",&pVTbl[i],&VTbl[2],VTbl[2]);                        
     ptrRelease=(ULONG(__stdcall*)(int)) VTbl[2];
     ptrRelease((int)&pVTbl[i]);                                               //Release()
     printf("%u\t%u\t%u\t",&pVTbl[i],&VTbl[3],VTbl[3]);                        
     pIFn=(void(__stdcall*)(int,int)) VTbl[3];
     pIFn((int)&pVTbl[i],i);                                                   //Fx1() / Fy1()    
     printf("%u\t%u\t%u\t",&pVTbl[i],&VTbl[4],VTbl[4]);                        
     pIFn=(void(__stdcall*)(int,int)) VTbl[4];
     pIFn((int)&pVTbl[i],i);                                                   //Fx2() / Fy2()   
     printf("\n");
 }
 ptrRelease=(ULONG(__stdcall*)(int)) VTbl[2];
 ptrRelease((int)&pVTbl[0]);
 CoUninitialize();
 getchar();

 return 0;
}

/*
sizeof(CA) = 12
this       = 10355664
Called CA::AddRef()
pVTbl   = 10355664

&pVTbl[i]       &VTbl[i]        VTbl[i]         Function Call Through Pointer
=============================================================================
10355664        268464396       268439696       Called CA::QueryInterface()
10355664        268464400       268439840       Called CA::AddRef()
10355664        268464404       268439872       Called CA::Release()
10355664        268464408       268439936       Called Fx1()  :  iNum = 0
10355664        268464412       268439968       Called Fx2()  :  iNum = 0

10355668        268464376       268440448       Called CA::QueryInterface()
10355668        268464380       268440464       Called CA::AddRef()
10355668        268464384       268440480       Called CA::Release()
10355668        268464388       268440000       Called Fy1()  :  iNum = 1
10355668        268464392       268440032       Called Fy2()  :  iNum = 1

Called CA::Release()
*/

