//CA.h                                    //the term interface means the same thing as a struct, which 
#include "IFunctions.h"                   //in PowerBASIC means the same thing as a good old BASIC TYPE.  
extern long g_lObjs;                      //This #define macro can be found in objbase.h.  Further, in   
extern long g_lLocks;                     //C++ structs are almost the same thing as classes except that

class CA : public I_X, public I_Y         //all their members are public by default, i.e., visible in
{                                         //inheriting classes.  That is the simple reason they are used.
 public:                                  //Now, when class CA is constructed by most C++ compilers a memory
 CA();            //Constructor           //allocation will be made for two pointers that point to other
 virtual ~CA();   //Destructor            //blocks of memory where pointers to the implemented functions 

 //Iunknown Functions                     //will be stored.  This is the virtual function table.  Our 
 virtual HRESULT __stdcall QueryInterface(const IID& iid, void** ppv);   //client programs will show its
 virtual ULONG   __stdcall AddRef();      //exact structure in withering detail.  Surfice it to say here   
 virtual ULONG   __stdcall Release();     //though that the block of memory CA allocates for interface I_X
                    
 //I_X Interface Methods/Functions        //(its virtual function table) will be 20 bytes, and the same  
 virtual HRESULT __stdcall Fx1(int);      //for interface I_Y.  This is because these interfaces, each of
 virtual HRESULT __stdcall Fx2(int);      //which only contains two functions, themselves inherit from  
 
 //I_ Interface Methods/Functions         //another struct, i.e., IUnknown, which itself contains pointers
 virtual HRESULT __stdcall Fy1(int);      //to three functions - QueryInterface(), AddRef(), and Release().
 virtual HRESULT __stdcall Fy2(int);      //This is the absolute most fundamental rule in the COM standard

 protected:                               //that all interfaces, i.e., structs, classes, virtual function
 long m_lRef;                             //tables, whatever you want to call them - must have pointers to
};                                        //QueryInterface(), AddRef(), and Release() as their first three 


class CAClassFactory : public IClassFactory                           //members.  You can easily see that  
{                                                                     //to be true by just looking directly 
 public:                                                              //left at the two classes there that
 CAClassFactory();                                                    //contain these functions.  Note that
 virtual ~CAClassFactory();                                           //it may not look like these functions
 
 public:                                                              //are at position one because they are
 //IUnknown                                                           //not first in the declarations, but that
 virtual HRESULT __stdcall QueryInterface(REFIID, void**);            //is somewhat confusing because the order
 virtual ULONG   __stdcall AddRef();                                  //of declaration there isn't the 
 virtual ULONG   __stdcall Release();                                 //controling factor, but rather the 

 //IclassFactory                                                      //controling factor is the inheritance
 virtual HRESULT __stdcall CreateInstance(LPUNKNOWN, REFIID, void**); //chain which forms the basis of the 
 virtual HRESULT __stdcall LockServer(BOOL);                          //class.  At left CAClassFactory inherits 

 protected:                                                           //from IclassFactory which is a system
 //Reference Count                                                    //defined class.  And in the declaration
 long  m_lRef;                                                        //of IclassFactory it would be found that
};                                                                    //it itself inherits from IUnknown.
//End CA.h
